// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AISS16AO2/include/16aiss16ao2_utils.h $
// $Rev: 52923 $
// $Date: 2023-04-20 15:40:25 -0500 (Thu, 20 Apr 2023) $

// 16AISS16AO2: Utilities: header file

#ifndef	__16AISS16AO2_UTILS_H__
#define	__16AISS16AO2_UTILS_H__

#include "16aiss16ao2_api.h"
#include "gsc_utils.h"
#include "gsc_utils_pci.h"



// prototypes *****************************************************************

// API utility services

int	aiss16ao2_close_util			(int fd, int index, int verbose);
int aiss16ao2_init_util				(int verbose);
int aiss16ao2_ioctl_util			(int fd, int index, int verbose, int request, void* arg);
int	aiss16ao2_open_util				(int device, int share, int index, int verbose, int* fd);
int	aiss16ao2_read_util				(int fd, int index, int verbose, void* dst, size_t bytes);
int	aiss16ao2_write_util			(int fd, int index, int verbose, const void* src, size_t bytes);

// IOCTL utility services

int	aiss16ao2_ai_buf_clear			(int fd, int index, int verbose);								// AISS16AO2_IOCTL_AI_BUF_CLEAR
int	aiss16ao2_ai_buf_level			(int fd, int index, int verbose, s32* get);						// AISS16AO2_IOCTL_AI_BUF_LEVEL
int	aiss16ao2_ai_buf_overflow		(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_AI_BUF_OVERFLOW
int	aiss16ao2_ai_buf_underflow		(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_AI_BUF_UNDERFLOW
int	aiss16ao2_ai_burst_enable		(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_AI_BURST_ENABLE
int	aiss16ao2_ai_burst_size			(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_AI_BURST_SIZE
int	aiss16ao2_ai_burst_status		(int fd, int index, int verbose, s32* get);						// AISS16AO2_IOCTL_AI_BURST_STATUS
int	aiss16ao2_ai_chan_sel			(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_AI_CHAN_SEL
int	aiss16ao2_ai_clock_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_AI_CLOCK_MODE
int	aiss16ao2_ai_enable				(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_AI_ENABLE
int	aiss16ao2_ai_fsamp_range		(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_AI_FSAMP_RANGE
int	aiss16ao2_ai_mode				(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_AI_MODE
int	aiss16ao2_ai_range_a			(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_AI_RANGE_A
int	aiss16ao2_ai_range_b			(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_AI_RANGE_B
int	aiss16ao2_ai_sw_clock			(int fd, int index, int verbose);								// AISS16AO2_IOCTL_AI_SW_CLOCK
int	aiss16ao2_ai_sw_trigger			(int fd, int index, int verbose);								// AISS16AO2_IOCTL_AI_SW_TRIGGER
int	aiss16ao2_ai_thresh_lvl			(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_AI_THRESH_LVL
int	aiss16ao2_ai_thresh_sts			(int fd, int index, int verbose, s32* get);						// AISS16AO2_IOCTL_AI_THRESH_STS
int	aiss16ao2_ao_buf_clear			(int fd, int index, int verbose);								// AISS16AO2_IOCTL_AO_BUF_CLEAR
int	aiss16ao2_ao_buf_level			(int fd, int index, int verbose, s32* get);						// AISS16AO2_IOCTL_AO_BUF_LEVEL
int	aiss16ao2_ao_buf_load_req		(int fd, int index, int verbose);								// AISS16AO2_IOCTL_AO_BUF_LOAD_REQ
int	aiss16ao2_ao_buf_load_sts		(int fd, int index, int verbose, s32* get);						// AISS16AO2_IOCTL_AO_BUF_LOAD_STS
int	aiss16ao2_ao_buf_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_AO_BUF_MODE
int	aiss16ao2_ao_buf_over_data		(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_AO_BUF_OVER_DATA
int	aiss16ao2_ao_buf_over_fram		(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_AO_BUF_OVER_FRAM
int	aiss16ao2_ao_burst_enable		(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_AO_BURST_ENABLE
int	aiss16ao2_ao_burst_status		(int fd, int index, int verbose, s32* get);						// AISS16AO2_IOCTL_AO_BURST_STATUS
int	aiss16ao2_ao_chan_sel			(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_AO_CHAN_SEL
int	aiss16ao2_ao_clock_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_AO_CLOCK_MODE
int	aiss16ao2_ao_clock_status		(int fd, int index, int verbose, s32* get);						// AISS16AO2_IOCTL_AO_CLOCK_STATUS
int	aiss16ao2_ao_enable				(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_AO_ENABLE
int	aiss16ao2_ao_mode				(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_AO_MODE
int	aiss16ao2_ao_output_mode		(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_AO_OUTPUT_MODE
int	aiss16ao2_ao_range				(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_AO_RANGE
int	aiss16ao2_ao_sw_clock			(int fd, int index, int verbose);								// AISS16AO2_IOCTL_AO_SW_CLOCK
int	aiss16ao2_ao_sw_trigger			(int fd, int index, int verbose);								// AISS16AO2_IOCTL_AO_SW_TRIGGER
int	aiss16ao2_ao_thresh_lvl			(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_AO_THRESH_LVL
int	aiss16ao2_ao_thresh_sts			(int fd, int index, int verbose, s32* get);						// AISS16AO2_IOCTL_AO_THRESH_STS
int	aiss16ao2_auto_cal_sts			(int fd, int index, int verbose, s32* get);						// AISS16AO2_IOCTL_AUTO_CAL_STS
int	aiss16ao2_auto_calibrate		(int fd, int index, int verbose);								// AISS16AO2_IOCTL_AUTO_CALIBRATE
int	aiss16ao2_data_format			(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_DATA_FORMAT
int	aiss16ao2_dio_dir_out			(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_DIO_DIR_OUT
int	aiss16ao2_dio_read				(int fd, int index, int verbose, s32* get);						// AISS16AO2_IOCTL_DIO_READ
int	aiss16ao2_dio_write				(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_DIO_WRITE
int	aiss16ao2_gen_a_enable			(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_GEN_A_ENABLE
int	aiss16ao2_gen_a_ndiv			(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_GEN_A_NDIV
int	aiss16ao2_gen_b_enable			(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_GEN_B_ENABLE
int	aiss16ao2_gen_b_ndiv			(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_GEN_B_NDIV
int	aiss16ao2_gen_c_enable			(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_GEN_C_ENABLE
int	aiss16ao2_gen_c_ndiv			(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_GEN_C_NDIV
int	aiss16ao2_initialize			(int fd, int index, int verbose);								// AISS16AO2_IOCTL_INITIALIZE
int	aiss16ao2_irq_enable			(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_IRQ_ENABLE
int	aiss16ao2_master_clock			(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_MASTER_CLOCK
int	aiss16ao2_query					(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_QUERY
int	aiss16ao2_reg_mod				(int fd, int index, int verbose, u32 reg, u32 value, u32 mask);	// AISS16AO2_IOCTL_REG_MOD
int	aiss16ao2_reg_read				(int fd, int index, int verbose, u32 reg, u32* value);			// AISS16AO2_IOCTL_REG_READ
int	aiss16ao2_reg_write				(int fd, int index, int verbose, u32 reg, u32 value);			// AISS16AO2_IOCTL_REG_WRITE
int	aiss16ao2_rx_io_abort			(int fd, int index, int verbose, s32* get);						// AISS16AO2_IOCTL_RX_IO_ABORT
int	aiss16ao2_rx_io_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_RX_IO_MODE
int	aiss16ao2_rx_io_overflow		(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_RX_IO_OVERFLOW
int	aiss16ao2_rx_io_timeout			(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_RX_IO_TIMEOUT
int	aiss16ao2_rx_io_underflow		(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_RX_IO_UNDERFLOW
int	aiss16ao2_trigger_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_TRIGGER_MODE
int	aiss16ao2_tx_io_abort			(int fd, int index, int verbose, s32* get);						// AISS16AO2_IOCTL_TX_IO_ABORT
int	aiss16ao2_tx_io_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_TX_IO_MODE
int	aiss16ao2_tx_io_overflow		(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_TX_IO_OVERFLOW
int	aiss16ao2_tx_io_timeout			(int fd, int index, int verbose, s32 set, s32* get);			// AISS16AO2_IOCTL_TX_IO_TIMEOUT
int	aiss16ao2_wait_cancel			(int fd, int index, int verbose, gsc_wait_t* wait);				// AISS16AO2_IOCTL_WAIT_CANCEL
int	aiss16ao2_wait_event			(int fd, int index, int verbose, gsc_wait_t* wait);				// AISS16AO2_IOCTL_WAIT_EVENT
int	aiss16ao2_wait_status			(int fd, int index, int verbose, gsc_wait_t* wait);				// AISS16AO2_IOCTL_WAIT_STATUS

// Auxiliary utility services

int	aiss16ao2_config_ai				(int fd, int index, int verbose, s32 rate, s32 master_clock);
int	aiss16ao2_config_ao				(int fd, int index, int verbose, s32 rate, s32 master_clock);
int	aiss16ao2_fsamp_ai_compute		(int fd, int index, int verbose, s32 fsamp, s32* ndiv, s32* range, double* rate);
int	aiss16ao2_fsamp_ai_report		(int fd, int index, int verbose, int chan, s32* fsamp);
int	aiss16ao2_fsamp_ai_report_all	(int fd, int index, int verbose, s32* fsamp);
int	aiss16ao2_fsamp_ao_compute		(int fd, int index, int verbose, s32 fsamp, s32* ndiv, double* rate);
int	aiss16ao2_fsamp_ao_report		(int fd, int index, int verbose, int chan, s32* fsamp);
int	aiss16ao2_fsamp_ao_report_all	(int fd, int index, int verbose, s32* fsamp);
int	aiss16ao2_id_device				(int fd, int index, int verbose);

int	aiss16ao2_count_boards			(int verbose, s32* get);
int	aiss16ao2_fsamp_ai_get			(int fd, int title, s32* get, s32* range);
int	aiss16ao2_fsamp_ao_get			(int fd, int title, s32* get);
int	aiss16ao2_reg_list				(int fd, int detail);

const gsc_reg_def_t*				aiss16ao2_reg_get_def_id		(u32 reg);
const gsc_reg_def_t*				aiss16ao2_reg_get_def_index		(int index);
const char*							aiss16ao2_reg_get_desc			(u32 reg);
const char*							aiss16ao2_reg_get_name			(u32 reg);



#endif
