// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AISS16AO2/samples/sbtest/ai_burst_size.c $
// $Rev: 52930 $
// $Date: 2023-04-20 15:46:28 -0500 (Thu, 20 Apr 2023) $

// 16AISS16AO2: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_BURST_SIZE,
			/* arg		*/	0x00000000,
			/* reg		*/	AISS16AO2_GSC_AIBBSR,
			/* mask		*/	0x00FFFFFF,
			/* value	*/	0x00000000
		},


		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_BURST_SIZE,
			/* arg		*/	0x00000001,
			/* reg		*/	AISS16AO2_GSC_AIBBSR,
			/* mask		*/	0x00FFFFFF,
			/* value	*/	0x00000001
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_BURST_SIZE,
			/* arg		*/	0x00000002,
			/* reg		*/	AISS16AO2_GSC_AIBBSR,
			/* mask		*/	0x00FFFFFF,
			/* value	*/	0x00000002
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_BURST_SIZE,
			/* arg		*/	0x00000004,
			/* reg		*/	AISS16AO2_GSC_AIBBSR,
			/* mask		*/	0x00FFFFFF,
			/* value	*/	0x00000004
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_BURST_SIZE,
			/* arg		*/	0x00000008,
			/* reg		*/	AISS16AO2_GSC_AIBBSR,
			/* mask		*/	0x00FFFFFF,
			/* value	*/	0x00000008
		},

		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_BURST_SIZE,
			/* arg		*/	0x00000010,
			/* reg		*/	AISS16AO2_GSC_AIBBSR,
			/* mask		*/	0x00FFFFFF,
			/* value	*/	0x00000010
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_BURST_SIZE,
			/* arg		*/	0x00000020,
			/* reg		*/	AISS16AO2_GSC_AIBBSR,
			/* mask		*/	0x00FFFFFF,
			/* value	*/	0x00000020
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_BURST_SIZE,
			/* arg		*/	0x00000040,
			/* reg		*/	AISS16AO2_GSC_AIBBSR,
			/* mask		*/	0x00FFFFFF,
			/* value	*/	0x00000040
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_BURST_SIZE,
			/* arg		*/	0x00000080,
			/* reg		*/	AISS16AO2_GSC_AIBBSR,
			/* mask		*/	0x00FFFFFF,
			/* value	*/	0x00000080
		},

		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_BURST_SIZE,
			/* arg		*/	0x00000100,
			/* reg		*/	AISS16AO2_GSC_AIBBSR,
			/* mask		*/	0x00FFFFFF,
			/* value	*/	0x00000100
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_BURST_SIZE,
			/* arg		*/	0x00000200,
			/* reg		*/	AISS16AO2_GSC_AIBBSR,
			/* mask		*/	0x00FFFFFF,
			/* value	*/	0x00000200
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_BURST_SIZE,
			/* arg		*/	0x00000400,
			/* reg		*/	AISS16AO2_GSC_AIBBSR,
			/* mask		*/	0x00FFFFFF,
			/* value	*/	0x00000400
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_BURST_SIZE,
			/* arg		*/	0x00000800,
			/* reg		*/	AISS16AO2_GSC_AIBBSR,
			/* mask		*/	0x00FFFFFF,
			/* value	*/	0x00000800
		},

		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_BURST_SIZE,
			/* arg		*/	0x00001000,
			/* reg		*/	AISS16AO2_GSC_AIBBSR,
			/* mask		*/	0x00FFFFFF,
			/* value	*/	0x00001000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_BURST_SIZE,
			/* arg		*/	0x00002000,
			/* reg		*/	AISS16AO2_GSC_AIBBSR,
			/* mask		*/	0x00FFFFFF,
			/* value	*/	0x00002000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_BURST_SIZE,
			/* arg		*/	0x00004000,
			/* reg		*/	AISS16AO2_GSC_AIBBSR,
			/* mask		*/	0x00FFFFFF,
			/* value	*/	0x00004000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_BURST_SIZE,
			/* arg		*/	0x00008000,
			/* reg		*/	AISS16AO2_GSC_AIBBSR,
			/* mask		*/	0x00FFFFFF,
			/* value	*/	0x00008000
		},

		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_BURST_SIZE,
			/* arg		*/	0x00010000,
			/* reg		*/	AISS16AO2_GSC_AIBBSR,
			/* mask		*/	0x00FFFFFF,
			/* value	*/	0x00010000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_BURST_SIZE,
			/* arg		*/	0x00020000,
			/* reg		*/	AISS16AO2_GSC_AIBBSR,
			/* mask		*/	0x00FFFFFF,
			/* value	*/	0x00020000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_BURST_SIZE,
			/* arg		*/	0x00040000,
			/* reg		*/	AISS16AO2_GSC_AIBBSR,
			/* mask		*/	0x00FFFFFF,
			/* value	*/	0x00040000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_BURST_SIZE,
			/* arg		*/	0x00080000,
			/* reg		*/	AISS16AO2_GSC_AIBBSR,
			/* mask		*/	0x00FFFFFF,
			/* value	*/	0x00080000
		},

		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_BURST_SIZE,
			/* arg		*/	0x00100000,
			/* reg		*/	AISS16AO2_GSC_AIBBSR,
			/* mask		*/	0x00FFFFFF,
			/* value	*/	0x00100000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_BURST_SIZE,
			/* arg		*/	0x00200000,
			/* reg		*/	AISS16AO2_GSC_AIBBSR,
			/* mask		*/	0x00FFFFFF,
			/* value	*/	0x00200000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_BURST_SIZE,
			/* arg		*/	0x00400000,
			/* reg		*/	AISS16AO2_GSC_AIBBSR,
			/* mask		*/	0x00FFFFFF,
			/* value	*/	0x00400000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_BURST_SIZE,
			/* arg		*/	0x00800000,
			/* reg		*/	AISS16AO2_GSC_AIBBSR,
			/* mask		*/	0x00FFFFFF,
			/* value	*/	0x00800000
		},

		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_BURST_SIZE,
			/* arg		*/	0x00FFFFFF,
			/* reg		*/	AISS16AO2_GSC_AIBBSR,
			/* mask		*/	0x00FFFFFF,
			/* value	*/	0x00FFFFFF
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= aiss16ao2_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= service_ioctl_reg_get_list(fd, list);

	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= service_ioctl_reg_get_list(fd, list);

	errs	+= aiss16ao2_initialize(fd, -1, 0);
	return(errs);
}




//*****************************************************************************
static int _function_test(int fd)
{
	static const service_data_t	list_1[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_CLOCK_MODE,
			/* arg		*/	AISS16AO2_CLOCK_MODE_OUT,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_GEN_A_NDIV,
			/* arg		*/	45,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_GEN_A_ENABLE,
			/* arg		*/	AISS16AO2_GEN_ENABLE_YES,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_FSAMP_RANGE,
			/* arg		*/	AISS16AO2_FSAMP_RANGE_HIGH,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_CHAN_SEL,
			/* arg		*/	0x1,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_TRIGGER_MODE,
			/* arg		*/	AISS16AO2_TRIGGER_MODE_OUT,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_BURST_ENABLE,
			/* arg		*/	AISS16AO2_BURST_ENABLE_YES,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_ENABLE,
			/* arg		*/	AISS16AO2_AIO_ENABLE_YES,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	service_data_t	list_2[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_BURST_SIZE,
			/* arg		*/	1,	// set below
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AI_SW_TRIGGER,
			/* arg		*/	0,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_SLEEP,
			/* cmd		*/	0,
			/* arg		*/	1,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	int	errs	= 0;
	int	i;
	s32	lvl;
	int	qty		= 0;
	int	ret;

	errs	+= aiss16ao2_initialize(fd, -1, 0);
	errs	+= service_ioctl_set_reg_list(fd, list_1);

	for (i = 1; (errs == 0) && (i < 16); i++)
	{
		ret	= aiss16ao2_ioctl(fd, AISS16AO2_IOCTL_AI_BUF_LEVEL, &lvl);

		if (ret)
		{
			errs++;
			break;
		}
		else if (lvl != qty)
		{
			errs++;
			printf("FAIL <---  (expected %ld, got %ld)\n", (long) qty, (long) lvl);
			break;
		}

		// Get more data.
		qty				+= i;
		list_2[0].arg	= i;
		errs			+= service_ioctl_set_reg_list(fd, list_2);
	}

	errs	+= aiss16ao2_initialize(fd, -1, 0);
	return(errs);
}




/******************************************************************************
*
*	Function:	ai_burst_size_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AISS16AO2_IOCTL_AI_BURST_SIZE.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ai_burst_size_test(int fd)
{
	int	errs	= 0;

	gsc_label("AISS16AO2_IOCTL_AI_BURST_SIZE");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


