// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AISS16AO2/samples/sbtest/auto_cal_sts.c $
// $Rev: 52930 $
// $Date: 2023-04-20 15:46:28 -0500 (Thu, 20 Apr 2023) $

// 16AISS16AO2: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	// There are no persistant bits to test.
	return(0);
}




//*****************************************************************************
static int _function_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AUTO_CALIBRATE,
			/* arg		*/	0,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	int	errs	= 0;
	int	ret;
	s32	sts		= 0;

	errs	+= aiss16ao2_initialize(fd, -1, 0);

	ret		= aiss16ao2_ioctl(fd, AISS16AO2_IOCTL_AUTO_CAL_STS, &sts);
	errs	+= ret ? 1 : 0;

	if ((errs == 0) && (sts != AISS16AO2_AUTO_CAL_STS_PASS))
	{
		errs++;
		printf("FAIL <---  (%d. status != PASS)\n", __LINE__);
	}

	errs	+= service_ioctl_set_reg_list(fd, list);

	ret		= aiss16ao2_ioctl(fd, AISS16AO2_IOCTL_AUTO_CAL_STS, &sts);
	errs	+= ret ? 1 : 0;

	if ((errs == 0) && (sts != AISS16AO2_AUTO_CAL_STS_PASS))
	{
		errs++;
		printf("FAIL <---  (%d. status != PASS)\n", __LINE__);
	}

	errs	+= aiss16ao2_initialize(fd, -1, 0);
	return(errs);
}




/******************************************************************************
*
*	Function:	auto_cal_sts_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AISS16AO2_IOCTL_AUTO_CAL_STS.
*		We can't verify that an auto-calibration was performed, so we simply
*		check that the respective bits are correct afterwards.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int auto_cal_sts_test(int fd)
{
	int	errs	= 0;

	gsc_label("AISS16AO2_IOCTL_AUTO_CAL_STS");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


