// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AISS16AO2/samples/sbtest/irq_enable.c $
// $Rev: 52930 $
// $Date: 2023-04-20 15:46:28 -0500 (Thu, 20 Apr 2023) $

// 16AISS16AO2: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_IRQ_ENABLE,
			/* arg		*/	0,
			/* reg		*/	AISS16AO2_GSC_PSR,
			/* mask		*/	0x4FFF,
			/* value	*/	0x0000
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;
	int	i;

	errs	+= aiss16ao2_initialize(fd, -1, 0);

	for (i = 0; i <= 14; i++)
	{
		// Walking one.
		list[0].arg		= 0x4FFF & (1 << i);
		list[0].value	= list[0].arg;

		errs	+= service_ioctl_set_reg_list(fd, list);
		errs	+= service_ioctl_reg_get_list(fd, list);

		errs	+= service_ioctl_set_reg_list(fd, list);
		errs	+= service_ioctl_reg_get_list(fd, list);

		// Walking zero.
		list[0].arg		= 0x4FFF ^ (1 << i);
		list[0].value	= 0x4FFF & list[0].arg;

		errs	+= service_ioctl_set_reg_list(fd, list);
		errs	+= service_ioctl_reg_get_list(fd, list);

		errs	+= service_ioctl_set_reg_list(fd, list);
		errs	+= service_ioctl_reg_get_list(fd, list);
	}

	errs	+= aiss16ao2_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	// The interrupts are tested via the Wait Event test code.
	return(0);
}



/******************************************************************************
*
*	Function:	irq_enable_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AISS16AO2_IOCTL_IRQ_ENABLE.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int irq_enable_test(int fd)
{
	int	errs	= 0;

	gsc_label("AISS16AO2_IOCTL_IRQ_ENABLE");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


