// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AISS16AO2/samples/sbtest/tx_io_overflow.c $
// $Rev: 52930 $
// $Date: 2023-04-20 15:46:28 -0500 (Thu, 20 Apr 2023) $

// 16AISS16AO2: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_TX_IO_OVERFLOW,
			/* arg		*/	AISS16AO2_IO_OVERFLOW_IGNORE,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_TX_IO_OVERFLOW,
			/* arg		*/	AISS16AO2_IO_OVERFLOW_CHECK,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= aiss16ao2_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_get_list(fd, list);

	errs	+= service_ioctl_set_get_list(fd, list);

	errs	+= aiss16ao2_initialize(fd, -1, 0);
	return(errs);
}




//*****************************************************************************
static int _function_test(int fd)
{
	static const service_data_t	list_1[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AO_BUF_MODE,
			/* arg		*/	AISS16AO2_BUF_MODE_OPEN,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AO_BURST_ENABLE,
			/* arg		*/	AISS16AO2_BURST_ENABLE_NO,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AO_ENABLE,
			/* arg		*/	AISS16AO2_AIO_ENABLE_NO,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AO_MODE,
			/* arg		*/	AISS16AO2_AO_MODE_FIFO,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_TX_IO_MODE,
			/* arg		*/	GSC_IO_MODE_PIO,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_TX_IO_TIMEOUT,
			/* arg		*/	1,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	static const service_data_t	list_2[]	=
	{
		{				// Cause a data overflow
			/* service	*/	SERVICE_REG_MOD,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	AISS16AO2_GSC_AOBR,
			/* mask		*/	0xFFFF,
			/* value	*/	0xFFFF
		},
		{				// Verify that we got an overflow.
			/* service	*/	SERVICE_REG_TEST,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	AISS16AO2_GSC_BOOR,
			/* mask		*/	0x10000,
			/* value	*/	0x10000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_TX_IO_OVERFLOW,
			/* arg		*/	AISS16AO2_IO_OVERFLOW_IGNORE,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	static const service_data_t	list_3[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_TX_IO_OVERFLOW,
			/* arg		*/	AISS16AO2_IO_OVERFLOW_CHECK,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	static const service_data_t	list_4[]	=
	{
		{					// Remove the data overflow.
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AO_BUF_OVER_DATA,
			/* arg		*/	AISS16AO2_BUF_OVERFLOW_CLEAR,
			/* reg		*/	AISS16AO2_GSC_BOOR,
			/* mask		*/	0x10000,
			/* value	*/	0x00000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AO_BUF_MODE,
			/* arg		*/	AISS16AO2_BUF_MODE_CIRC,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{					// Cause a frame overflow
			/* service	*/	SERVICE_REG_MOD,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	AISS16AO2_GSC_AOBR,
			/* mask		*/	0xFFFF,
			/* value	*/	0xFFFF
		},
		{					// Verify a frame overflow.
			/* service	*/	SERVICE_REG_TEST,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	AISS16AO2_GSC_BOOR,
			/* mask		*/	0x20000,
			/* value	*/	0x20000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_TX_IO_OVERFLOW,
			/* arg		*/	AISS16AO2_IO_OVERFLOW_IGNORE,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	u32		data[1];
	int		errs	= 0;
	long	l;
	int		ret;

	errs	+= aiss16ao2_initialize(fd, -1, 0);
	errs	+= service_ioctl_set_reg_list(fd, list_1);

	// Fill the output FIFO and cause an overflow.
	data[0]	= 0;

	for (l = 0; l < (256L * 1024); l++)
	{
		ret	= aiss16ao2_write(fd, data, 4);

		if (ret != 4)
		{
			errs++;
			printf(	"FAIL <---  (%d. aiss16ao2_write(): returned %d, expected 4)\n",
					__LINE__,
					ret);
		}
	}

	// Verify that IGNORE works on a data overflow.
	errs	+= service_ioctl_set_reg_list(fd, list_2);

	if (errs == 0)
	{
		ret	= aiss16ao2_write(fd, data, 4);

		if (ret != 0)
		{
			errs++;
			printf(	"FAIL <---  (%d. aiss16ao2_write(): returned %d, expected 0)\n",
					__LINE__,
					ret);
		}
	}

	// Verify that CHECK works on a data overflow.
	errs	+= service_ioctl_set_get_list(fd, list_3);

	if (errs == 0)
	{
		ret	= aiss16ao2_write(fd, data, 4);

		if (ret >= 0)
		{
			errs++;
			printf(	"FAIL <---  (%d. aiss16ao2_write(): returned %d, expected an error)\n",
					__LINE__,
					ret);
		}
	}

	// Verify that IGNORE works on a frame overflow.
	errs	+= service_ioctl_set_reg_list(fd, list_4);

	if (errs == 0)
	{
		ret	= aiss16ao2_write(fd, data, 4);

		if (ret < 0)
		{
			errs++;
			printf(	"FAIL <---  (%d. aiss16ao2_write(): returned %d, expected 0)\n",
					__LINE__,
					ret);
		}
	}

	// Verify that CHECK works on a frame overflow.
	errs	+= service_ioctl_set_get_list(fd, list_3);

	if (errs == 0)
	{
		ret	= aiss16ao2_write(fd, data, 4);

		if (ret >= 0)
		{
			errs++;
			printf(	"FAIL <---  (%d. aiss16ao2_write(): returned %d, expected an error)\n",
					__LINE__,
					ret);
		}
	}

	errs	+= aiss16ao2_initialize(fd, -1, 0);
	return(errs);
}




/******************************************************************************
*
*	Function:	tx_io_overflow_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AISS16AO2_IOCTL_TX_IO_OVERFLOW.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int tx_io_overflow_test(int fd)
{
	int	errs	= 0;

	gsc_label("AISS16AO2_IOCTL_TX_IO_OVERFLOW");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


